<html>
    <head>
<style>
        #maincontainer {
            width:100%;
            height: 100%;
        }
        
        #decyphered_txt_sub {
            float:left;
            display:inline-block;
            width: 210px;
            height: 100%;
            background: #eeeeee;
        }
        
        #decyphered_txt_add {
            float:left;
            display:inline-block;
            width: -moz-calc(100% - 210px);
            width: -webkit-calc(100% - 210px);
            width: calc(100% - 210px);
            height: 100%;
            background-color: #cccccc;
        }
        </style>
<script type="text/javascript" src="dict/ITALIANO.A" ></script>
<script type="text/javascript" src="dict/ITALIANO.B" ></script>
<script type="text/javascript" src="dict/ITALIANO.C" ></script>
<script type="text/javascript" src="dict/ITALIANO.D" ></script>
<script type="text/javascript" src="dict/ITALIANO.E" ></script>
<script type="text/javascript" src="dict/ITALIANO.F" ></script>
<script type="text/javascript" src="dict/ITALIANO.G" ></script>
<script type="text/javascript" src="dict/ITALIANO.H" ></script>
<script type="text/javascript" src="dict/ITALIANO.I" ></script>
<script type="text/javascript" src="dict/ITALIANO.J" ></script>
<script type="text/javascript" src="dict/ITALIANO.K" ></script>
<script type="text/javascript" src="dict/ITALIANO.L" ></script>
<script type="text/javascript" src="dict/ITALIANO.M" ></script>
<script type="text/javascript" src="dict/ITALIANO.N" ></script>
<script type="text/javascript" src="dict/ITALIANO.O" ></script>
<script type="text/javascript" src="dict/ITALIANO.P" ></script>
<script type="text/javascript" src="dict/ITALIANO.Q" ></script>
<script type="text/javascript" src="dict/ITALIANO.R" ></script>
<script type="text/javascript" src="dict/ITALIANO.S" ></script>
<script type="text/javascript" src="dict/ITALIANO.T" ></script>
<script type="text/javascript" src="dict/ITALIANO.U" ></script>
<script type="text/javascript" src="dict/ITALIANO.V" ></script>
<script type="text/javascript" src="dict/ITALIANO.W" ></script>
<script type="text/javascript" src="dict/ITALIANO.X" ></script>
<script type="text/javascript" src="dict/ITALIANO.Y" ></script>
<script type="text/javascript" src="dict/ITALIANO.Z" ></script>
<script type="text/javascript">

//TODO: server side generated
const CLIENT_INSTANCE_ID = 14329;


const linear_cyph_text = [
5,	8,	6,	20,	9,	18,	5,	10,	14,	26,	22,
17,18,	14,	28,	21,	18,	18,	10,	21,	9,	22,
5, 24,	10,	17,	14,	17,	19,	22,	11,	10,	5,
15,3,	23,	14,	7,	8,	13,	18,	15,	22,	9,
23,19,	29,	19,	9,	11,	8,	19,	5,	18,	22,
9,	4,	23,	18,	22,	7,	9,	19,	28,	17,	14,
20,28,	22,	7,	8,	9,	11,	19,	25,	17,	19,
22,23,	28,	9,	14,	6,	22,	17,	10,	9,	14,
11,11,	15,	17,	7,	8,	11,	24,	16,	9,	19,
26,5,	13,	9,	8,	10,	11,	14,	9,	18,	8,
19,20,	5,	16,	19,	15,	8,	11,	14,	14,	2,
21,13,	9,	7,	17,	19,	19,	5,	17,	7,	16,
20,19,	7,	17,	13,	25,	23,	13,	23,	23,	23,
18,13,	6,	17,	23,	14,	7,	15,	5,	18,	13,
12,13,	22,	6,	27,	21,	20,	20,	10,	14,	9,
18,22,	9,	5,	15,	14,	19,	15,	18,	30,	21,
14,22,	14,	26,	13,	13,	5,	22,	14,	14,	13,
18,7,	8,	26,	17,	15,	9,	1,	10,	26,	16,
10,26,	21,	6,	27,	4,	29,	11,	27,	16,	1
];

const alphabet_num = [
{"n":1, "c":'a'},
{"n":2, "c":'b'},
{"n":3, "c":'c'},
{"n":4, "c":'d'},
{"n":5, "c":'e'},
{"n":6, "c":'f'},
{"n":7, "c":'g'},
{"n":8, "c":'h'},
{"n":9, "c":'i'},
{"n":10, "c":'j'},
{"n":11, "c":'k'},
{"n":12, "c":'l'},
{"n":13, "c":'m'},
{"n":14, "c":'n'},
{"n":15, "c":'o'},
{"n":16, "c":'p'},
{"n":17, "c":'q'},
{"n":18, "c":'r'},
{"n":19, "c":'s'},
{"n":20, "c":'t'},
{"n":21, "c":'u'},
{"n":22, "c":'v'},
{"n":23, "c":'w'},
{"n":24, "c":'x'},
{"n":25, "c":'y'},
{"n":26, "c":'z'}
];

function saveResult(client, txt, likelihood){
    const result_URL = "result.php";
    return new Promise(function(resolve, reject){
		var httpReq = new XMLHttpRequest();
		httpReq.onreadystatechange = function() {
			var data;
			if (httpReq.readyState == 4) {
				if (httpReq.status == 200) {
					resolve("OK");
				} else {
					reject(new Error(httpReq.statusText));
				}
			}
        };
        
        httpReq.open("POST", result_URL, true);
        httpReq.setRequestHeader("Content-type", "application/x-www-form-urlencoded");
        httpReq.send("client=" + client + "&txt=" + txt + "&likelihood=" + likelihood);
    });
}

function num2txt(nn){
        for(index = 0; index < alphabet_num.length; index++){
            if(alphabet_num[index].n == nn)
                return alphabet_num[index].c;
        }

        return nn > 0 ? "*" : "-";
}

function txt2num(key_ch){
    for(index = 0; index < alphabet_num.length; index++){
        if(alphabet_num[index].c == key_ch)
            return alphabet_num[index].n;
    }

    return 0;
}

function nextKey(){
    var key_txt = document.getElementById("keytext").value;

    let key_char_array = key_txt.split('');
    let key = key_char_array.map(txt2num);

    let max = Math.max.apply(Math, alphabet_num.map(function(a) { return a.n; }));
    let min = Math.min.apply(Math, alphabet_num.map(function(a) { return a.n; }));

    function inc(index){
        if(key[index] == max){
            key[index] = min;
            return true;
        }
        key[index]++;
        return false;
    }

    index = 0;
    while(inc(index) && index < key.length)
    index++;

    document.getElementById("keytext").value = key.map(num2txt).join("");
    applyDecypheringKey();
}


function applyDecypheringKey(){
    var key_txt = document.getElementById("keytext").value;

    let key_char_array = key_txt.split('');
    let key = key_char_array.map(txt2num);

    linear_decyphered_num_sub = linear_cyph_text.map(function decyph(elem, i){ return elem - key[i % key.length] + 1; });

    linear_decyphered_txt_sub = linear_decyphered_num_sub.map(num2txt);

    document.getElementById("decyphered_txt_sub").innerHTML = linear_decyphered_txt_sub.join(" ");

    linear_decyphered_txt = linear_decyphered_txt_sub.join("");
    var likelihood = calculateLikelihood(linear_decyphered_txt);

    if(likelihoodOverAverage(likelihood)){
        updateStatistics(key_txt, likelihood);
        saveResult(CLIENT_INSTANCE_ID, linear_decyphered_txt, likelihood)
        .then(nextKey);
    }
    else
        nextKey();
}

const dictionary = [a, b, c, d, e, f, g, h, i, j, k, l, m, n, o, p, q, r, s, t, u, v, w, x, y, z];

function calculateLikelihood(txt){
    const MAX_SUBSTR_LENGTH = 3;
    let chunks = [];
    for(index = 0; index < txt.length - MAX_SUBSTR_LENGTH; index++){
        chunks[index] = txt.substring(index, MAX_SUBSTR_LENGTH);
    }
    
    likelihood_result = chunks.map(function (chunk){
        return dictionary.reduce(function(tot_occurences, words){
            return words.reduce(function (occurences, word){
                if(word.includes(chunk))
                    occurences++;
                return occurences;
            }, 0);
        }, 0);
    }).reduce(function(tot, curr){ return tot+curr;}, 0);

    return likelihood_result;
}

</script>
    </head>
<body>
<div>
<input id="keytext" onkeyup="applyDecypheringKey();" />
</div>
<div id="maincontainer">
        <div style="max-width: 211px; font-family: 'Courier New', Courier, monospace" id="decyphered_txt_sub"></div>
        <div style="max-width: 211px; font-family: 'Courier New', Courier, monospace" id="decyphered_txt_add"></div>
</div>
</body>
</html>
